/*
  Frequ synth for Kraco CB
  Denys VK3ZYZ (with help from Google and others) 
*/

#define Version "KracoKCB2340_VFO_20230921PM"

#include "si5351.h"
#include "Wire.h"
#include "Adafruit_GFX.h"
#include "Adafruit_SSD1306.h"
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

// synthesiser default settings on start up.
unsigned long A_Crystal  = 23290000;
unsigned long B_Crystal  = 14950000;
float frequ = 23.290;

#define       RX                LOW
int           TRXmode         = RX;          // HIGH = TX, LOW = RX
int           channel         = 1;           // convert frequence to channel number
int encoder;                                 // encoder direction: CCW=-1; NC=0; CW=1
int timer = 100;           // sub tone setting. The higher the number, the slower the timing.
int  i ;
unsigned long temp;
int temp2;

int32_t cal_factor = 32400; //  <<<--- found from Si5351 calibrator sketch.

Si5351 clockgen;                             // initalize clockgen

// encoder definitions
#define ENCODER_A     A0
#define ENCODER_B     A1
#define spare         A2           // not used yet
#define ModeSwitch    A3           // extra mode selector
// A4 = SDA
// A5 = SCL
#define AnalogIn1     A6           // not used yet
#define AnalogIn2     A7           // not used yet
 
#define TRX            2           // input HIGH = TX, LOW = RX.
#define Input2         3           // not used yet
#define Output1        4           // not used yet
#define REV_SWITCH     5           // Encoder Button  repeater reverse
#define spareSW        6           // not used yet

/* ********************* PortB0-PB5 used to generate CTCSS tones via R2R nerwork.
#define spare1         8           // Sub Tone R2R b0 PB0
#define spare2         9           // Sub Tone R2R b1 PB1
#define spare3        10           // Sub Tone R2R b2 PB2
#define spare4        11           // Sub Tone R2R b3 PB3
#define spare5        12           // Sub Tone R2R b4 PB4
#define spare6        13           // Sub Tone R2R b5 PB5
*/

#define ENCODER_INPUT_PORT PINC
#define On  1
#define Off 0


  
long int A_CrystalFrequs []      // Edit this for frequencies wanted.
{ 23290,  // 26.965  1
  23290,  // 26.975  2
  23290,  // 26.985  3
          // 26.995 not used
  23290,  // 27.005  4
  23340,  // 27.015  5
  23340,  // 27.025  6
  23340,  // 27.035  7
          // 27.045 not used
  23340,  // 27.055  8
  23390,  // 27.065  9
  23390,  // 27.075 10
  23390,  // 27.085 11
          // 27.095 not used
  23390,  // 27.105 12
  23440,  // 27.115 13
  23440,  // 27.125 14
  23440,  // 27.135 15
          // 27.145 not used
  23440,  // 27.155 16
  23490,  // 27.165 17
  23490,  // 27.175 18
  23490,  // 27.185 19
          // 27.195 not used
  23490,  // 27.205 20
  23540,  // 27.215 21
  23540,  // 27.225 22
          // Note swapped order for some channels
  23540,  // 27.255 23  ************
  23540,  // 27.235 24  ************
  23540,  // 27.245 25  ************
  23590,  // 27.265 26
  23590,  // 27.275 27
  23590,  // 27.285 28
  23590,  // 27.295 29
  23590,  // 27.305 30
  23640,  // 27.315 31
  23640,  // 27.325 32
  23640,  // 27.335 33
  23640,  // 27.345 34
  23640,  // 27.355 35
  23690,  // 27.365 36
  23690,  // 27.375 37
  23690,  // 27.385 38
  23690,  // 27.395 39 
  23690,  // 27.405 40
};

long int B_CrystalFrequs []      // Edit this for frequencies wanted.
{ 14950,  // 26.965  1
  14960,  // 26.975  2
  14970,  // 26.985  3
          // 26.995 not used
  14990,  // 27.005  4
  14950,  // 27.015  5
  14960,  // 27.025  6
  14970,  // 27.035  7
          // 27.045 not used
  14990,  // 27.055  8
  14950,  // 27.065  9
  14960,  // 27.075 10
  14970,  // 27.085 11
          // 27.095 not used
  14990,  // 27.105 12
  14950,  // 27.115 13
  14960,  // 27.125 14
  14970,  // 27.135 15
          // 27.145 not used
  14990,  // 27.155 16
  14950,  // 27.165 17
  14960,  // 27.175 18
  14970,  // 27.185 19
          // 27.195 not used
  14990,  // 27.205 20
  14950,  // 27.215 21
  14960,  // 27.225 22
          // Note swapped order for some channels
  14980,  // 27.245 23  ************
  14970,  // 27.235 24  ************
  14990,  // 27.255 25  ************
  14950,  // 27.265 26
  14960,  // 27.275 27
  14970,  // 27.285 28
  14980,  // 27.295 29
  14990,  // 27.305 30
  14950,  // 27.315 31
  14960,  // 27.325 32
  14970,  // 27.335 33
  14980,  // 27.345 34
  14990,  // 27.355 35
  14950,  // 27.365 36
  14960,  // 27.375 37
  14970,  // 27.385 38
  14980,  // 27.395 39 
  14990,  // 27.405 40
};
int Chans_18 []
{ 0, 0, 0, 0, 1, 2, 3, 4, 5, 0, 6, 8, 9,10,11,12,13,14,15,17,
  0,18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
};

void setup() {
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // Address 0x3C for 128x32
  display.clearDisplay();
  display.display();                  // Update screen
  display.setTextSize(1);             // Normal 1:1 pixel scale
  display.setTextColor(WHITE,BLACK);  // Draw white text
  display.setCursor(0,0);             // Start at top-left corner
  display.println(F(Version));
  display.display(); // Update screen
  delay(1000);
  display.clearDisplay();
  display.display();                  // Update screen
  delay(100);
  clockgen.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);
  clockgen.set_correction(cal_factor, SI5351_PLL_INPUT_XO); // <<<<<<<this is found from Si5351 calibrator code.

  // configure rotary encoder & push-button
  // do not use INPUT_PULLUP if encoder has built in pulups
  pinMode(ENCODER_A, INPUT);     // encoder leads
  pinMode(ENCODER_B, INPUT);
  pinMode(REV_SWITCH, INPUT);    // Hi = nomal, LOW =  Reverse
  pinMode(TRX, INPUT);     // Hi = TX, LOW =  RX
  pinMode(Input2, INPUT_PULLUP);
  pinMode(Output1, OUTPUT);
  DDRB  = B111111;                // sets Arduino pins 7 to 12 as outputs.
  PORTB = B100000;                // R2R out at rest to half level.
  digitalWrite(Output1, HIGH);    // output1 off

  encoder = read_encoder();       // returns +1/0/-1 (cw/nc/ccw)
  TRXmode=(digitalRead(TRX));
  set_synth();
}

/******************************
  main loop
*******************************/
void loop() {


  if (digitalRead(TRX) !=TRXmode)                 // has the TX/RX mode changed?
    { TRXmode=(digitalRead(TRX));                 // Yes, set the mode to suit.
      set_synth();                                // set the freqs
    }
  if (TRXmode==RX)                                // check for frequency chanegs if RX only.
    { encoder = read_encoder();                   // returns +1/0/-1 (cw/nc/ccw)
      if (encoder != 0)                           // has the encoder been moved?
        { channel = channel + encoder;            // Yes, inc/dec channel number
          channel = constrain(channel, 0, 39);    // max 40 channels.
          set_synth();                            // set the  freqs
        }
  }                                               // end of RX mode adjustments
}

/******************************
  read encoder direction
*******************************/
int read_encoder() {
  // definitions
#define DELAY 100                               // number of polling-loops   
  static unsigned short integrator;               // encoder debounce

  /* the array values are determined by combining the previous and current A1,A0
    Gray Code bit-patterns to form an array-index. +1 is assigned to all clockwise
    (CW) indexes; -1 is assigned to all counter-clockwise (CCW) indexes; and 0 is
    assigned to the remaining positions to indicate no movement*/
  static char encoder[] = {0, -1, 1, 0, 1, 0, 0, -1, -1, 0, 0, 1, 0, 1, -1, 0}; // SWAPPED PHASES
  static unsigned char encoder_index = 0;
  static long count = 0;                         // CW rotation = +1; CCW rotation = -1
  static long this_reading;
  static long last_reading;
  char value;                                    // return value

  /* check for encoder rotation. The absolute "count" value changes as the encoder rotates.
    Typically there are four states (counts) per click, but often more due to contact bounce.
    Bounce doesn't matter so long as the "count" decreases" for CCW rotation; remains constant
    when there is no rotation; and increases with CW rotation. Bounce can be completely
    eliminated if we look for the "detent" code and integrate as shown below. */
  encoder_index <<= 2;                           // shift previous bit-pattern left two places
  encoder_index |= (ENCODER_INPUT_PORT & 0x03);  // get current bit-pattern and combine with previous
  count += encoder[( encoder_index & 0x0f )];

  // debounce encoder
  if ((ENCODER_INPUT_PORT & 0x03) == 3) {        // encoder on an indent (3 decimal == 00000011 binary)
    if (integrator < DELAY) {
      integrator++;
    }
  } else {                                       // encoder not resting on indent
    if (integrator > 0) {
      integrator--;
    }
  }

  // prepare the "return" value
  if (integrator >= DELAY) {                     // encoder deemed to be stationary
    this_reading = count;
    if (this_reading < last_reading) value = -1;
    if (this_reading == last_reading) value = 0;
    if (this_reading > last_reading) value = 1;
    last_reading = this_reading;                 // both readings now hold current "count"
    integrator = 0;                              // reset integrator
  } else {
    value = 0;
  }
  return (value);
}

/*******************************
  set the Si5351 frequencies
 ******************************/
 
void set_synth()       // set the display and PLL
{  A_Crystal = (A_CrystalFrequs[channel]);  
   B_Crystal = (B_CrystalFrequs[channel]);
   frequ=(((A_Crystal+B_Crystal)-11275)*.001);  // calculate the frequ
                                            // write frequ to the LCD
  display.setTextSize(1);                   // Normal 1:1 pixel scale
  display.setCursor(18,0);
  display.print(frequ,3);
  display.display();                       // Update screen
  
  if ( TRXmode == RX)                      // is it = RX?
    {  display.setTextColor(WHITE,BLACK);  // normal Display;
    }
   else                                    // No, it is TX.
    { display.setTextColor(BLACK,WHITE);   // Invert Display
    }
                                           // write channel number to the LCD
  display.setCursor(1,10);                 // position the cursor
  display.setTextSize(3);                  // and large text                  
 // display.print("  ");                      // clear the old number
   display.print("        ");                      // clear the old number
  display.setCursor(1,10);                  // write channel number to the LCD
  if (channel < 9)                          // "9" = 10 as array starts at 0
  { display.print(" ");                     // extra space for formatting a single digit.
  }
  display.print((channel + 1));             // display the channel number

int temp = Chans_18 [channel];
  display.setCursor(80,10);                 // position the cursor
  display.setTextSize(2);                  // and large text                  
  display.print("  ");                      // clear the old number
  if (temp >0)
  {display.setCursor(80,10);                  // write channel number to the LCD
   if (temp < 10)                          // 
   { display.print(" ");                     // extra space for formatting a single digit.
   } 
   display.print(temp);
  }
  display.setTextColor(WHITE,BLACK);      // back to normal text
  display.display();                      // Update screen
   
// calculate the actual frequencies to set
    clockgen.output_enable(SI5351_CLK0, 1);                 // turn RX gen on
    clockgen.set_freq((A_Crystal * 100000), SI5351_CLK0);   // set the RX generator frequ,
    clockgen.output_enable(SI5351_CLK1, 1);                 // turn TX gen on
    clockgen.set_freq((B_Crystal * 100000), SI5351_CLK1);   // set the RX generator frequ,
  }
